// SemSample.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "SemSample.h"
#include "server.h"
#include "resource.h"

// Z}tHуZ}tH̍őJEg
// őJEǵC󋵕\pRg[̐ƍ킹Kv
#define	NAME_SEMAPHORE		_T("NSW_SEMSAMPLE")
#define	MAX_COUNT			4

// bZ[W񓙂̒`
#define	DLG_TITLE			_T("Semaphore Object Tester")
#define	CAPTION_IDLE		_T("ҋ@")
#define	CAPTION_EXITING		_T("I")
#define	MSG_SOCKETERROR		_T("\PbgʐMG[܂B")

// IWiEJ[̒`
#define	MYCOLOR_GREEN		RGB(153, 255, 204)
#define	MYCOLOR_YELLOW		RGB(255, 255, 153)
#define	MYCOLOR_RED			RGB(255, 153, 102)


// SendRequestThreadɓnp[^\
struct SendReqParam
{
	HWND hDlg;			// _CAOE{bNX̃EBhEEvV[W
	int ctrlID;			// ꂽ{^ɑΉRg[ID
	const char *cmd;	// R}h
};

HANDLE g_hSem = NULL;
HINSTANCE g_hInst;

static HWND g_hDlg = 0;
static CRITICAL_SECTION g_cs;	// e[ǔr䂷

// GUI\[X
static HICON g_hicGreen;
static HICON g_hicYellow;
static HICON g_hicRed;
static HBRUSH g_hbrGreen;
static HBRUSH g_hbrYellow;
static HBRUSH g_hbrRed;
static HBRUSH g_hbrText1 = 0;
static HBRUSH g_hbrText2 = 0;
static HBRUSH g_hbrText3 = 0;
static HBRUSH g_hbrText4 = 0;

// gp\ȏ󋵕\pRg[ID̃e[u
// (ϒƂCIDC_ENDe[u̖[B
//  IDC_EMPTY͎gp̃Gg)
#define	IDC_END		IDC_STATIC
#define	IDC_EMPTY	0
static int g_ctrlTable[] = {
	IDC_TEXT1, IDC_TEXT2, IDC_TEXT3, IDC_TEXT4, IDC_END
};


// g_ctrlTablegp\ȃRg[IDĕԂ
int AcquireCtrlID(void)
{
	int ctrlID = 0;
	EnterCriticalSection(&g_cs);
	int *ptr = g_ctrlTable;
	while(*ptr != IDC_END){
		if(*ptr != IDC_EMPTY){
			ctrlID = *ptr;
			*ptr = IDC_EMPTY;
			break;
		}
		ptr++;
	}
	LeaveCriticalSection(&g_cs);
	return ctrlID;
}

// AcquireCtrlIDŊlRg[ԋp
void ReleaseCtrlID(int ctrlID)
{
	EnterCriticalSection(&g_cs);
	int *ptr = g_ctrlTable;
	while(*ptr != IDC_END){
		if(*ptr == IDC_EMPTY){
			*ptr = ctrlID;
			break;
		}
		ptr++;
	}
	LeaveCriticalSection(&g_cs);
}

// w肵Rg[̔wiFύX
// ctrlIDAcquireCtrlIDŊlRg[IDw肵C
// colorɂCTLCOLOR_xxxw肷B
void SetCtrlColor(int ctrlID, int color)
{
	HBRUSH hbr = 0;
	switch(color){
	case CTLCOLOR_GREEN:
		hbr = g_hbrGreen;
		break;
		
	case CTLCOLOR_YELLOW:
		hbr = g_hbrYellow;
		break;
		
	case CTLCOLOR_RED:
		hbr = g_hbrRed;
		break;
	}
	
	switch(ctrlID){
	case IDC_TEXT1:
		g_hbrText1 = hbr;
		break;
		
	case IDC_TEXT2:
		g_hbrText2 = hbr;
		break;
		
	case IDC_TEXT3:
		g_hbrText3 = hbr;
		break;
		
	case IDC_TEXT4:
		g_hbrText4 = hbr;
		break;
	}
}

// w肵Rg[̏ԂύX
// ctrlIDAcquireCtrlIDŊlRg[IDw肵C
// colorɂCTLSTATE_xxxw肷B
void SetCtrlState(int ctrlID, int state, int option)
{
	switch(state){
	case CTLSTATE_IDLE:
		SetDlgItemText(g_hDlg, ctrlID, CAPTION_IDLE);
		break;
		
	case CTLSTATE_EXITING:
		SetDlgItemText(g_hDlg, ctrlID, CAPTION_EXITING);
		break;
		
	case CTLSTATE_COUNTDOWN:
		SetDlgItemInt(g_hDlg, ctrlID, option, TRUE);
		break;
	}
}

// T[o[Ɏw肳ꂽR}h𑗐MXbhEvV[W
static
unsigned __stdcall SendRequestThread(void *param)
{
	SendReqParam *pParam = (SendReqParam *)param;
	if(pParam->ctrlID >= 0){
		EnableWindow(GetDlgItem(pParam->hDlg, pParam->ctrlID), FALSE);
	}
	
	SOCKET s;
	if((s = socket(AF_INET, SOCK_STREAM, 0)) != INVALID_SOCKET){
		struct sockaddr_in client;
		client.sin_family = AF_INET;
		client.sin_port   = htons(SERVER_PORT);
		client.sin_addr.s_addr = inet_addr("127.0.0.1");
		
		if(connect(s, (struct sockaddr *)&client, sizeof(client)) == 0){
			char cmd[MAX_CMD_LEN];
			strcpy(cmd, pParam->cmd);
			send(s, cmd, strlen(cmd) + 1, 0);
			recv(s, cmd, sizeof(cmd), 0);
		}
		else{
			MessageBox(pParam->hDlg, MSG_SOCKETERROR, DLG_TITLE, MB_OK);
		}
		
		shutdown(s, 1);
		closesocket(s);
	}
	else{
		MessageBox(pParam->hDlg, MSG_SOCKETERROR, DLG_TITLE, MB_OK);
	}
	
	if(pParam->ctrlID >= 0){
		EnableWindow(GetDlgItem(pParam->hDlg, pParam->ctrlID), TRUE);
	}
	free(pParam);
	return 0;
}

// SendRequestThreadʃXbhƂċNāCT[o[ɃR}h𑗐M
void SendRequest(HWND hDlg, UINT ctrlID, const char *cmd)
{
	SendReqParam *pParam = (SendReqParam *)malloc(sizeof(SendReqParam));
	pParam->hDlg = hDlg;
	pParam->ctrlID = ctrlID;
	pParam->cmd = cmd;
	(void)_beginthreadex(NULL, 0, SendRequestThread, pParam, 0, NULL);
}

// CEEBhEł_CAÕvV[W
INT_PTR CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg){
	case WM_INITDIALOG:
	{
		g_hDlg = hDlg;
		
		// T[o[EXbhN
		StartServer();
		
		// Kvȃ\[X̍쐬ѐݒ
		g_hbrGreen  = CreateSolidBrush(MYCOLOR_GREEN);
		g_hbrYellow = CreateSolidBrush(MYCOLOR_YELLOW);
		g_hbrRed    = CreateSolidBrush(MYCOLOR_RED);
		
		RECT rc;
		GetClientRect(GetDlgItem(hDlg, IDC_REQUEST1), &rc);
		g_hicGreen  = (HICON)LoadImage(
								g_hInst, MAKEINTRESOURCE(IDI_GREEN),
								IMAGE_ICON, rc.right, rc.right, 0);
		g_hicYellow = (HICON)LoadImage(
								g_hInst, MAKEINTRESOURCE(IDI_YELLOW),
								IMAGE_ICON, rc.right, rc.right, 0);
		g_hicRed    = (HICON)LoadImage(
								g_hInst, MAKEINTRESOURCE(IDI_RED),
								IMAGE_ICON, rc.right, rc.right, 0);
		
		SendDlgItemMessage(hDlg, IDC_REQUEST1, BM_SETIMAGE,
								(WPARAM)IMAGE_ICON, (LPARAM)g_hicGreen);
		SendDlgItemMessage(hDlg, IDC_REQUEST2, BM_SETIMAGE,
								(WPARAM)IMAGE_ICON, (LPARAM)g_hicYellow);
		SendDlgItemMessage(hDlg, IDC_REQUEST3, BM_SETIMAGE,
								(WPARAM)IMAGE_ICON, (LPARAM)g_hicRed);
		
		return TRUE;
	}
	
	case WM_DESTROY:
		// 쐬\[X̌n
		DeleteObject(g_hbrGreen);
		DeleteObject(g_hbrYellow);
		DeleteObject(g_hbrRed);
		DestroyIcon(g_hicGreen);
		DestroyIcon(g_hicYellow);
		DestroyIcon(g_hicRed);
		
		g_hDlg = 0;
		return FALSE;
		
	case WM_CTLCOLORSTATIC:
	{
		// X^eBbNERg[̔wiFݒ肷B
		// ܂CLvV̔wiF𓧉߂ɂB
		HBRUSH hbr = 0;
		HDC hdc = (HDC)wParam;
		SetBkMode(hdc, TRANSPARENT);
		int ctrlID = GetDlgCtrlID((HWND)lParam);
		switch(ctrlID){
		case IDC_TEXT1:
			hbr = g_hbrText1;
			break;
			
		case IDC_TEXT2:
			hbr = g_hbrText2;
			break;
			
		case IDC_TEXT3:
			hbr = g_hbrText3;
			break;
		
		case IDC_TEXT4:
			hbr = g_hbrText4;
			break;
		}
		return (LRESULT)hbr;
	}
	
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return TRUE;
		
		case IDC_REQUEST1:
			SendRequest(hDlg, IDC_REQUEST1, CMD_GREEN);
			return TRUE;
			
		case IDC_REQUEST2:
			SendRequest(hDlg, IDC_REQUEST2, CMD_YELLOW);
			return TRUE;
			
		case IDC_REQUEST3:
			SendRequest(hDlg, IDC_REQUEST3, CMD_RED);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	UNREFERENCED_PARAMETER(nCmdShow);

	g_hInst = hInstance;
	
	// \PbgAPȈ
	WORD wVersionRequested = MAKEWORD(2, 2);
	WSADATA wsaData;
	if(WSAStartup(wVersionRequested, &wsaData) != 0){
		MessageBox(0, MSG_SOCKETERROR, DLG_TITLE, MB_OK);
		return -1;
	}
	
	// ֘ÃZbgAbv
	InitializeCriticalSection(&g_cs);
	g_hSem = CreateSemaphore(NULL, MAX_COUNT, MAX_COUNT, NAME_SEMAPHORE);
	
	// CE_CAŐN
	DialogBox(0, MAKEINTRESOURCE(IDD_DIALOG), 0, DlgProc);
	
	// ֘Ǎn
	CloseHandle(g_hSem);
	DeleteCriticalSection(&g_cs);

	// \PbgAPȈI
	WSACleanup();
	
	return 0;
}
